(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/portal'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('angular-walkthrough', ['exports', '@angular/core', '@angular/cdk/portal', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory(global['angular-walkthrough'] = {}, global.ng.core, global.ng.cdk.portal, global.rxjs, global.rxjs.operators, global.ng.common));
}(this, function (exports, core, portal, rxjs, operators, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var booleanValue = (/**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return value === 'true' || value === true;
    });
    var WalkthroughEvent = /** @class */ (function () {
        function WalkthroughEvent(component, focusElement) {
            this.component = component;
            this.focusElement = focusElement;
        }
        return WalkthroughEvent;
    }());
    var WalkthroughMargin = /** @class */ (function () {
        function WalkthroughMargin(top, right, bottom, left) {
            if (top === void 0) { top = 0; }
            this.top = top;
            this.right = right;
            this.bottom = bottom;
            this.left = left;
            if (right === undefined) {
                this.right = top;
            }
            if (bottom === undefined) {
                this.bottom = top;
            }
            if (left === undefined && right === undefined) {
                this.left = top;
            }
            else if (left === undefined) {
                this.left = right;
            }
        }
        /**
         * @param {?} points
         * @return {?}
         */
        WalkthroughMargin.parsePoints = /**
         * @param {?} points
         * @return {?}
         */
        function (points) {
            /** @type {?} */
            var pointsPx;
            if (points.match(/^\d+(?:\s+\d+)*$/)) {
                /** @type {?} */
                var split = points.split(/\s+/).map((/**
                 * @param {?} i
                 * @return {?}
                 */
                function (i) { return parseFloat(i); }));
                pointsPx = new WalkthroughMargin(split[0], split[1], split[2], split[3]);
            }
            return pointsPx || new WalkthroughMargin();
        };
        return WalkthroughMargin;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WalkthroughService = /** @class */ (function () {
        function WalkthroughService() {
            this._overflowRegex = /(auto|scroll)/;
        }
        /**
         * @param {?} element
         * @param {?=} margin
         * @return {?}
         */
        WalkthroughService.prototype.retrieveCoordinates = /**
         * @param {?} element
         * @param {?=} margin
         * @return {?}
         */
        function (element, margin) {
            /** @type {?} */
            var clientrect = element.getBoundingClientRect();
            /** @type {?} */
            var style = window.getComputedStyle(element);
            /** @type {?} */
            var coordinates = {
                top: clientrect.top - (margin ? margin.top : 0),
                height: clientrect.height,
                width: clientrect.width,
                left: clientrect.left - (margin ? margin.left : 0),
                margin: {
                    top: parseFloat(style.marginTop),
                    right: parseFloat(style.marginRight),
                    bottom: parseFloat(style.marginBottom),
                    left: parseFloat(style.marginLeft),
                }
            };
            coordinates.top += this.getTop();
            return coordinates;
        };
        /**
         * @return {?}
         */
        WalkthroughService.prototype.getTop = /**
         * @return {?}
         */
        function () {
            return window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;
        };
        /**
         * @return {?}
         */
        WalkthroughService.prototype.getDocumentHeight = /**
         * @return {?}
         */
        function () {
            // Height of entire body : https://stackoverflow.com/a/1147768
            /** @type {?} */
            var body_height = Math.max(document.body.scrollHeight, document.body.offsetHeight, document.documentElement.clientHeight, document.documentElement.scrollHeight, document.documentElement.offsetHeight);
            return Math.max(this.getHeightOfPage() + this.getTop(), body_height);
        };
        /**
         * @param {?} element
         * @return {?}
         */
        WalkthroughService.prototype.scrollIntoViewIfOutOfView = /**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            /** @type {?} */
            var topOfPage = this.getTop();
            /** @type {?} */
            var heightOfPage = this.getHeightOfPage();
            /** @type {?} */
            var elementY = 0;
            /** @type {?} */
            var elementH = 0;
            /** @type {?} */
            var parent = element;
            while (parent && parent !== document.body) {
                elementY += parent.offsetTop;
                parent = (/** @type {?} */ (parent.offsetParent));
            }
            elementH = element.offsetHeight;
            if ((topOfPage + heightOfPage) < (elementY + elementH)) {
                element.scrollIntoView(false);
            }
            else if (elementY < topOfPage) {
                element.scrollIntoView(true);
                window.scrollBy(0, -30);
            }
            else {
                // test of overflow element
                /** @type {?} */
                var current = element;
                while (current && current !== document.body) {
                    parent = this.getScrollParent(current);
                    if (current.offsetTop + current.offsetHeight - parent.scrollTop > parent.offsetHeight ||
                        current.offsetLeft + current.offsetWidth - parent.scrollLeft > parent.offsetWidth) {
                        element.scrollIntoView();
                        window.scrollBy(0, -30);
                        break;
                    }
                    current = parent;
                }
            }
        };
        /**
         * @param {?} element1
         * @param {?} element2
         * @param {?} margin
         * @return {?}
         */
        WalkthroughService.prototype.scrollToTopElement = /**
         * @param {?} element1
         * @param {?} element2
         * @param {?} margin
         * @return {?}
         */
        function (element1, element2, margin) {
            if (element1 && element2) {
                /** @type {?} */
                var element1Position = this.retrieveCoordinates(element1, margin);
                /** @type {?} */
                var element2Position = this.retrieveCoordinates(element2, margin);
                /** @type {?} */
                var minX = Math.min(element1Position.left, element2Position.left);
                /** @type {?} */
                var minY = Math.min(element1Position.top, element2Position.top);
                window.scrollTo(minX - 20, minY - 20);
            }
        };
        /**
         * @param {?} element
         * @return {?}
         */
        WalkthroughService.prototype.getScrollParent = /**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            /** @type {?} */
            var scrollParent;
            /** @type {?} */
            var style = getComputedStyle(element);
            /** @type {?} */
            var excludeStaticParent = style.position === 'absolute';
            if (style.position !== 'fixed') {
                /** @type {?} */
                var parent_1 = element.parentElement;
                while (parent_1 && parent_1 !== document.body) {
                    style = getComputedStyle(parent_1);
                    if (!(excludeStaticParent && style.position === 'static') &&
                        this._overflowRegex.test(style.overflow + style.overflowY + style.overflowX)) {
                        scrollParent = parent_1;
                        break;
                    }
                    parent_1 = parent_1.parentElement;
                }
            }
            return scrollParent || document.body;
        };
        /**
         * @return {?}
         */
        WalkthroughService.prototype.getHeightOfPage = /**
         * @return {?}
         */
        function () {
            return window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
        };
        WalkthroughService.decorators = [
            { type: core.Injectable }
        ];
        return WalkthroughService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WalkthroughText = /** @class */ (function () {
        function WalkthroughText() {
            this.previous = 'Previous';
            this.next = 'Next';
            this.close = 'Close';
        }
        return WalkthroughText;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nextUniqueId = 0;
    /** @type {?} */
    var noInstanceWarn = 'No instance of walkthroughContainer.';
    /** @type {?} */
    var anoterWktOnGoing = 'Another walkthrough is ongoing. Please close it before opening a new one.';
    var WalkthroughComponent = /** @class */ (function () {
        function WalkthroughComponent(_componentFactoryResolver, _applicationRef, _injector, _renderer, _walkthroughService) {
            var _this = this;
            this._componentFactoryResolver = _componentFactoryResolver;
            this._applicationRef = _applicationRef;
            this._injector = _injector;
            this._renderer = _renderer;
            this._walkthroughService = _walkthroughService;
            this.closed = new core.EventEmitter();
            this.finished = new core.EventEmitter();
            this.ready = new core.EventEmitter();
            this.typeSelector = 'element';
            this.contentStyle = 'draken';
            this.animation = 'none';
            this.animationDelays = 0;
            this.scrollOnTarget = true;
            this._uid = "walkthrough-" + nextUniqueId++;
            this._readyHasBeenEmited = false;
            this._display = false;
            this._hasHighlightAnimation = false;
            this._hasBackdrop = false;
            this._hasGlow = false;
            this._hasFinish = false;
            this._hasArrow = false;
            this._hasCloseButton = false;
            this._hasCloseAnywhere = true;
            this._disabled = false;
            this._marginZonePx = new WalkthroughMargin();
            this._alignContent = 'left';
            this._verticalAlignContent = 'top';
            this._contentSpacing = 0;
            this._verticalContentSpacing = 50;
            this._onContainerInit = new rxjs.Subject();
            this._onResize = new rxjs.Subject();
            this._onResize.pipe(operators.debounceTime(200)).subscribe((/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var instance = _this._getInstance();
                if (instance && instance.ongoing && _this._display) {
                    _this._elementLocations();
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        _this._elementLocations();
                    }), 200);
                }
            }));
        }
        Object.defineProperty(WalkthroughComponent.prototype, "marginZone", {
            get: /**
             * @return {?}
             */
            function () { return this._marginZone; },
            set: /**
             * @param {?} points
             * @return {?}
             */
            function (points) {
                if (this._marginZone !== points) {
                    if (points === null) {
                        this._marginZone = null;
                    }
                    this._marginZonePx = WalkthroughMargin.parsePoints(points);
                    if (this._marginZonePx !== null) {
                        this._marginZone = points;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "arrowColor", {
            get: /**
             * @return {?}
             */
            function () { return this._arrowColor; },
            set: /**
             * @param {?} color
             * @return {?}
             */
            function (color) {
                if (this._arrowColor !== color) {
                    this._arrowColor = color;
                    if (this._getInstance()) {
                        this._getInstance().arrowColor = this._arrowColor;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "id", {
            get: /**
             * @return {?}
             */
            function () { return this._id; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._id = value || this._uid; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "alignContent", {
            get: /**
             * @return {?}
             */
            function () {
                return this._alignContent;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (this._alignContent !== value) {
                    this._alignContent = value;
                    this._updateElementPositions(this._getInstance());
                }
                else {
                    this._alignContent = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "verticalAlignContent", {
            get: /**
             * @return {?}
             */
            function () {
                return this._verticalAlignContent;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (this._verticalAlignContent !== value) {
                    this._verticalAlignContent = value;
                    this._updateElementPositions(this._getInstance());
                }
                else {
                    this._verticalAlignContent = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "contentSpacing", {
            get: /**
             * @return {?}
             */
            function () {
                return this._contentSpacing;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                value = Math.max(WalkthroughComponent.minimalMargin, value);
                if (this._contentSpacing !== value) {
                    this._contentSpacing = value * 1;
                    this._updateElementPositions(this._getInstance());
                }
                else {
                    this._contentSpacing = value * 1;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "verticalContentSpacing", {
            get: /**
             * @return {?}
             */
            function () {
                return this._verticalContentSpacing;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                value = Math.max(WalkthroughComponent.minimalMargin, value);
                if (this._verticalContentSpacing !== value) {
                    this._verticalContentSpacing = value * 1;
                    this._updateElementPositions(this._getInstance());
                }
                else {
                    this._verticalContentSpacing = value * 1;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "closeButton", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hasCloseButton;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hasCloseButton = booleanValue(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "closeAnywhere", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hasCloseAnywhere;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hasCloseAnywhere = booleanValue(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "showArrow", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hasArrow;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hasArrow = booleanValue(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "finishButton", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hasFinish;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hasFinish = booleanValue(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "focusHighlightAnimation", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hasHighlightAnimation;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hasHighlightAnimation = booleanValue(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "focusBackdrop", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hasBackdrop;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hasBackdrop = booleanValue(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "focusGlow", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hasGlow;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hasGlow = booleanValue(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughComponent.prototype, "disabled", {
            get: /**
             * @return {?}
             */
            function () {
                return this._disabled;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                var _this = this;
                this._disabled = value;
                /** @type {?} */
                var instance = this._getInstance();
                if (instance) {
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        instance.hasPrevious = _this._hasPreviousStep(instance);
                        instance.hasNext = _this._hasNextStep(instance);
                        if (!instance.hasNext) {
                            instance.hasFinish = true;
                        }
                        else {
                            instance.hasFinish = (/** @type {?} */ (instance.parent.finishButton));
                        }
                    }), 50);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WalkthroughComponent.walkthroughStop = /**
         * @return {?}
         */
        function () {
            if (WalkthroughComponent._walkthroughContainer) {
                WalkthroughComponent._walkthroughContainer.instance.stop();
            }
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.walkthroughHasShow = /**
         * @return {?}
         */
        function () {
            return WalkthroughComponent._walkthroughContainer
                ? WalkthroughComponent._walkthroughContainer.instance.show
                : false;
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.walkthroughHasPause = /**
         * @return {?}
         */
        function () {
            return WalkthroughComponent._walkthroughContainer
                ? WalkthroughComponent._walkthroughContainer.instance.pause
                : false;
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.walkthroughContinue = /**
         * @return {?}
         */
        function () {
            if (WalkthroughComponent._walkthroughContainer &&
                WalkthroughComponent._walkthroughContainer.instance.parent) {
                /** @type {?} */
                var visible = WalkthroughComponent._walkthroughContainer.instance.parent._checkVisibility();
                if (visible) {
                    WalkthroughComponent._walkthroughContainer.instance.continue();
                }
                else {
                    // we can't open the walkthrough anymore, the focusElementSelector is no more visible
                    // so we update the flag "ongoing"
                    WalkthroughComponent._walkthroughContainer.instance.ongoing = false;
                }
            }
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.walkthroughNext = /**
         * @return {?}
         */
        function () {
            if (WalkthroughComponent._walkthroughContainer) {
                WalkthroughComponent._walkthroughContainer.instance.next();
            }
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.walkthroughPrevious = /**
         * @return {?}
         */
        function () {
            if (WalkthroughComponent._walkthroughContainer) {
                WalkthroughComponent._walkthroughContainer.instance.previous();
            }
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.prototype.resize = /**
         * @return {?}
         */
        function () {
            this._onResize.next();
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            // init the Walkthrough element container
            if (!WalkthroughComponent._walkthroughContainer && !WalkthroughComponent._walkthroughContainerCreating) {
                WalkthroughComponent._walkthroughContainerCreating = true;
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    WalkthroughComponent._walkthroughContainer =
                        _this._appendComponentToBody(WalkthroughContainerComponent);
                    _this._onContainerInit.next();
                }));
            }
        };
        /**
         * @param {?=} closedEvent
         * @param {?=} finishedEvent
         * @return {?}
         */
        WalkthroughComponent.prototype.next = /**
         * @param {?=} closedEvent
         * @param {?=} finishedEvent
         * @return {?}
         */
        function (closedEvent, finishedEvent) {
            if (closedEvent) {
                this.closed = closedEvent;
            }
            if (finishedEvent) {
                this.finished = finishedEvent;
            }
            this.open();
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.prototype.refresh = /**
         * @return {?}
         */
        function () {
            if (this._getInstance()) {
                if (!this._getInstance().ongoing) {
                    WalkthroughComponent.onRefresh.next(this);
                    this._elementLocations();
                }
                else {
                    console.warn(anoterWktOnGoing);
                }
            }
            else {
                console.warn(noInstanceWarn);
            }
        };
        /**
         * @return {?}
         */
        WalkthroughComponent.prototype.open = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                if (_this._checkVisibility()) {
                    if (_this._getInstance()) {
                        resolve(_this._open());
                    }
                    else {
                        _this._onContainerInit.pipe(operators.first()).subscribe((/**
                         * @return {?}
                         */
                        function () {
                            if (_this._getInstance()) {
                                resolve(_this._open());
                            }
                            else {
                                console.warn(noInstanceWarn);
                                resolve(false);
                            }
                        }));
                    }
                }
                else {
                    resolve(false);
                }
            }));
        };
        /**
         * Do not use this method outside of the library
         */
        /**
         * Do not use this method outside of the library
         * @return {?}
         */
        WalkthroughComponent.prototype.loadPrevioustStep = /**
         * Do not use this method outside of the library
         * @return {?}
         */
        function () {
            var _this = this;
            setTimeout((/**
             * @return {?}
             */
            function () {
                WalkthroughComponent.onNavigate.next({ previous: _this, next: _this.previousStep });
                WalkthroughComponent.onNavigatePrevious.next({ previous: _this, next: _this.previousStep });
                _this.previousStep._next(_this.closed, _this.finished);
            }), 0);
        };
        /**
         * Do not use this method outside of the library
         */
        /**
         * Do not use this method outside of the library
         * @return {?}
         */
        WalkthroughComponent.prototype.loadNextStep = /**
         * Do not use this method outside of the library
         * @return {?}
         */
        function () {
            var _this = this;
            setTimeout((/**
             * @return {?}
             */
            function () {
                WalkthroughComponent.onNavigate.next({ previous: _this, next: _this.nextStep });
                WalkthroughComponent.onNavigateNext.next({ previous: _this, next: _this.nextStep });
                _this.nextStep._next(_this.closed, _this.finished);
            }), 0);
        };
        /**
         * Do not use this method outside of the library
         */
        /**
         * Do not use this method outside of the library
         * @param {?=} finishLink
         * @param {?=} closeWalkthrough
         * @return {?}
         */
        WalkthroughComponent.prototype.hide = /**
         * Do not use this method outside of the library
         * @param {?=} finishLink
         * @param {?=} closeWalkthrough
         * @return {?}
         */
        function (finishLink, closeWalkthrough) {
            var _this = this;
            if (finishLink === void 0) { finishLink = false; }
            if (closeWalkthrough === void 0) { closeWalkthrough = true; }
            this._display = false;
            // add CSS to focusElement
            if (this.focusElementCSSClass && this._focusElement) {
                this._renderer.removeClass(this._focusElement, this.focusElementCSSClass);
            }
            if (closeWalkthrough) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this._getInstance().ongoing = false;
                    WalkthroughComponent.onClose.next(_this);
                    // emit closed event
                    _this.closed.emit(finishLink);
                    if (!_this.nextStep) {
                        // emit finished event
                        WalkthroughComponent.onFinish.next(_this);
                        _this.finished.emit(new WalkthroughEvent(_this, _this._focusElement));
                    }
                }), 20);
            }
        };
        /**
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._checkVisibility = /**
         * @private
         * @return {?}
         */
        function () {
            var e_1, _a;
            if (this.focusElementSelector) {
                /** @type {?} */
                var elements = document.querySelectorAll(this.focusElementSelector);
                if (elements.length === 0) {
                    return false;
                }
                if (this.visibilityCallback) {
                    return this.visibilityCallback();
                }
                try {
                    for (var _b = __values((/** @type {?} */ (elements))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var el = _c.value;
                        if (el.offsetParent === null) {
                            return false;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            return true;
        };
        /**
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._open = /**
         * @private
         * @return {?}
         */
        function () {
            if (!this._getInstance().ongoing) {
                this._getInstance().ongoing = true;
                WalkthroughComponent.onOpen.next(this);
                this._elementLocations();
                return true;
            }
            else {
                console.warn(anoterWktOnGoing);
                return false;
            }
        };
        /**
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._show = /**
         * @private
         * @return {?}
         */
        function () {
            this._display = true;
        };
        /**
         * @private
         * @param {?=} closedEvent
         * @param {?=} finishedEvent
         * @return {?}
         */
        WalkthroughComponent.prototype._next = /**
         * @private
         * @param {?=} closedEvent
         * @param {?=} finishedEvent
         * @return {?}
         */
        function (closedEvent, finishedEvent) {
            if (closedEvent) {
                this.closed = closedEvent;
            }
            if (finishedEvent) {
                this.finished = finishedEvent;
            }
            /** @type {?} */
            var instance = this._getInstance();
            if (instance && instance.ongoing) {
                instance.ongoing = false;
            }
            this.open();
        };
        /**
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._getInstance = /**
         * @private
         * @return {?}
         */
        function () {
            return WalkthroughComponent._walkthroughContainer
                ? WalkthroughComponent._walkthroughContainer.instance
                : null;
        };
        /**
         * @private
         * @template T
         * @param {?} component
         * @return {?}
         */
        WalkthroughComponent.prototype._appendComponentToBody = /**
         * @private
         * @template T
         * @param {?} component
         * @return {?}
         */
        function (component) {
            // create a component reference
            /** @type {?} */
            var componentRef = this._componentFactoryResolver.resolveComponentFactory(component).create(this._injector);
            // attach component to the appRef so that so that it will be dirty checked.
            this._applicationRef.attachView(componentRef.hostView);
            // get DOM element from component
            /** @type {?} */
            var domElem = (/** @type {?} */ (((/** @type {?} */ (componentRef.hostView))).rootNodes[0]));
            document.body.appendChild(domElem);
            return componentRef;
        };
        /**
         * @private
         * @template T
         * @param {?} componentOrTemplateRef
         * @param {?} walkthroughContainer
         * @return {?}
         */
        WalkthroughComponent.prototype._attachWalkthroughContent = /**
         * @private
         * @template T
         * @param {?} componentOrTemplateRef
         * @param {?} walkthroughContainer
         * @return {?}
         */
        function (componentOrTemplateRef, walkthroughContainer) {
            if (componentOrTemplateRef instanceof core.TemplateRef) {
                walkthroughContainer.attachTemplatePortal(new portal.TemplatePortal(componentOrTemplateRef, null));
            }
            else {
                /** @type {?} */
                var injectionTokens = new WeakMap();
                injectionTokens.set(WalkthroughContainerComponent, walkthroughContainer);
                /** @type {?} */
                var injector = new portal.PortalInjector(this._injector, injectionTokens);
                walkthroughContainer.attachComponentPortal(new portal.ComponentPortal(componentOrTemplateRef, undefined, injector));
            }
        };
        /**
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._elementLocations = /**
         * @private
         * @return {?}
         */
        function () {
            this._getFocusElement();
            /** @type {?} */
            var element = this._focusElement;
            if (element) {
                if (this.scrollOnTarget) {
                    this._walkthroughService.scrollIntoViewIfOutOfView(element);
                }
                // if there is a root element defined (in some cases when position fixed is used, we need to scroll on it)
                if (this.rootElement) {
                    document.querySelector(this.rootElement).scrollIntoView(true);
                }
                this._offsetCoordinates = this._walkthroughService.retrieveCoordinates(element, this._marginZonePx);
                if (this.typeSelector === 'zone') {
                    /** @type {?} */
                    var offsetEndCoordinatesEnd = this._walkthroughService.retrieveCoordinates(this._focusElementEnd, this._marginZonePx);
                    this._offsetCoordinates.height = offsetEndCoordinatesEnd.top
                        - this._offsetCoordinates.top
                        + offsetEndCoordinatesEnd.height;
                    this._offsetCoordinates.width = offsetEndCoordinatesEnd.left
                        - this._offsetCoordinates.left
                        + offsetEndCoordinatesEnd.width;
                }
            }
            else {
                this._offsetCoordinates = null;
            }
            this._setFocus();
        };
        /**
         *
         */
        /**
         *
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._getFocusElement = /**
         *
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var focusElements;
            try {
                focusElements = this.focusElementSelector
                    ? (/** @type {?} */ (document.querySelectorAll(this.focusElementSelector)))
                    : null;
            }
            catch (error) {
                console.error("#" + this.id + "@focusElementSelector: '" + this.focusElementSelector + "' is not a valid selector.\n", error);
            }
            // getting focus element
            if (focusElements && focusElements.length > 0) {
                if (focusElements.length > 1) {
                    // Multiple items fit selector, displaying first visible as focus item in 'element' mode
                    /** @type {?} */
                    var l = focusElements.length;
                    for (var i = 0; i < l; i++) {
                        // offsetHeight not of 0 means visible
                        if (focusElements[i].offsetHeight) {
                            this._focusElement = focusElements[i];
                            i = focusElements.length;
                            break;
                        }
                    }
                    // if typeSelector is by zone, get also the last element
                    if (this.typeSelector === 'zone') {
                        for (var i = l - 1; i >= 0; i--) {
                            // offsetHeight not of 0 means visible
                            if (focusElements[i].offsetHeight) {
                                this._focusElementEnd = focusElements[i];
                                i = focusElements.length;
                                break;
                            }
                        }
                        // this the zone this just a unique element, change mode for 'element'
                        if (this._focusElement === this._focusElementEnd) {
                            this.typeSelector = 'element';
                        }
                    }
                }
                else {
                    this._focusElement = focusElements[0];
                    this.typeSelector = 'element';
                }
            }
            else {
                this._focusElement = null;
            }
        };
        /**
         * get instance, hightlight the focused element et show the template
         */
        /**
         * get instance, hightlight the focused element et show the template
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._setFocus = /**
         * get instance, hightlight the focused element et show the template
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var instance = this._getInstance();
            if (instance) {
                /** @type {?} */
                var scrollY_1 = window.pageXOffset;
                this._initStylingTemplate(instance);
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    if (_this._focusElement && instance.zone) {
                        instance.hightlightZone(_this._offsetCoordinates, scrollY_1 - window.pageXOffset, _this.animation, _this.animationDelays, _this._setFocusContinue.bind(_this));
                    }
                    else {
                        _this._setFocusContinue();
                    }
                }), 20);
            }
        };
        /**
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._setFocusContinue = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var instance = this._getInstance();
            if (!this._display) {
                this._attachContentTemplate();
                this._initContentTemplate(instance);
            }
            setTimeout((/**
             * @return {?}
             */
            function () {
                instance.hightlightZoneStyling(_this._focusElement);
                _this._updateElementPositions(instance);
            }), 0);
        };
        /**
         * @private
         * @param {?} instance
         * @return {?}
         */
        WalkthroughComponent.prototype._updateElementPositions = /**
         * @private
         * @param {?} instance
         * @return {?}
         */
        function (instance) {
            var _this = this;
            if (WalkthroughComponent._walkthroughContainer && this._getInstance()) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    instance.contentBlockPosition(_this._offsetCoordinates, _this._alignContent, _this._verticalAlignContent, _this._contentSpacing, _this._verticalContentSpacing);
                    if (_this._focusElement !== null && _this._hasArrow) {
                        instance.arrowPosition(_this._offsetCoordinates, _this._verticalContentSpacing);
                    }
                    // add CSS to focusElement
                    if (_this.focusElementCSSClass && _this._focusElement) {
                        _this._renderer.addClass(_this._focusElement, _this.focusElementCSSClass);
                    }
                    setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        _this._getInstance().setHeight();
                        if (!_this._readyHasBeenEmited) {
                            _this._readyHasBeenEmited = true;
                            _this.ready.emit(new WalkthroughEvent(_this, _this._focusElement));
                        }
                        /** @type {?} */
                        var contentBlockNative = (/** @type {?} */ (instance.contentBlock.nativeElement));
                        /** @type {?} */
                        var scrollPos;
                        if (_this._focusElement != null) {
                            /** @type {?} */
                            var coordinatesContent = _this._walkthroughService.retrieveCoordinates(contentBlockNative);
                            /** @type {?} */
                            var coordinatesFocus = _this._walkthroughService.retrieveCoordinates(_this._focusElement);
                            // is content + focus higher than window ?
                            if (coordinatesContent.height + coordinatesFocus.height > window.innerHeight) {
                                // we scroll on content
                                contentBlockNative.scrollIntoView(true);
                                // we offset the window half of the content height
                                if (coordinatesContent.top > coordinatesFocus.top) {
                                    // content below focusZone
                                    scrollPos = -(coordinatesContent.height / 2);
                                }
                                else {
                                    // content above focusZone
                                    scrollPos = +(coordinatesContent.height / 2);
                                }
                            }
                            else {
                                // scroll on element higher minus minimal margin
                                if (coordinatesContent.top > coordinatesFocus.top) {
                                    window.scrollTo(coordinatesFocus.left, coordinatesFocus.top);
                                    scrollPos = -WalkthroughComponent.minimalMargin;
                                }
                                else {
                                    contentBlockNative.scrollIntoView(true);
                                    scrollPos = -WalkthroughComponent.minimalMargin;
                                }
                            }
                        }
                        else {
                            // no focus zone, scroll on content minus margin
                            contentBlockNative.scrollIntoView(true);
                            scrollPos = -WalkthroughComponent.minimalMargin;
                        }
                        window.scrollBy(0, scrollPos);
                    }), 50);
                }), 0);
            }
        };
        /**
         * Attache the template in the contener, if a template is linked.
         */
        /**
         * Attache the template in the contener, if a template is linked.
         * @private
         * @return {?}
         */
        WalkthroughComponent.prototype._attachContentTemplate = /**
         * Attache the template in the contener, if a template is linked.
         * @private
         * @return {?}
         */
        function () {
            if (this.contentTemplate) {
                this._attachWalkthroughContent(this.contentTemplate, this._getInstance());
            }
        };
        /**
         * init a partof styles of the contenaire
         */
        /**
         * init a partof styles of the contenaire
         * @private
         * @param {?} instance
         * @return {?}
         */
        WalkthroughComponent.prototype._initStylingTemplate = /**
         * init a partof styles of the contenaire
         * @private
         * @param {?} instance
         * @return {?}
         */
        function (instance) {
            /** @type {?} */
            var hasHighlightZone = this._focusElement !== null;
            instance.parent = this;
            instance.open();
            instance.hasHighlightZone = hasHighlightZone;
            instance.hasClickable = hasHighlightZone && typeof this.focusClick === 'function';
            instance.hasHighlight = hasHighlightZone && this._hasHighlightAnimation;
            instance.hasBackdrop = this._hasBackdrop;
            instance.hasGlow = hasHighlightZone && this._hasGlow;
        };
        /**
         * init all datas of the contenaire
         */
        /**
         * init all datas of the contenaire
         * @private
         * @param {?} instance
         * @return {?}
         */
        WalkthroughComponent.prototype._initContentTemplate = /**
         * init all datas of the contenaire
         * @private
         * @param {?} instance
         * @return {?}
         */
        function (instance) {
            /** @type {?} */
            var hasHighlightZone = this._focusElement !== null;
            instance.hasPrevious = this._hasPreviousStep(instance);
            instance.hasNext = this._hasNextStep(instance);
            instance.hasCloseButton = this._hasCloseButton;
            instance.hasCloseAnywhere = this._hasCloseAnywhere;
            instance.hasFinish = this._hasFinish || !instance.hasNext;
            instance.hasArrow = hasHighlightZone && this._hasArrow;
            instance.arrowColor = this.arrowColor;
            instance.radius = this.radius;
            instance.marginZone = this._marginZone ? this._marginZone.replace(/(\d+)/g, '$1px') : null;
            instance.marginZonePx = this._marginZonePx;
            instance.contentText = this.contentText;
            instance.contentStyle = this.contentStyle;
            instance.text = this.texts
                ? __assign({}, new WalkthroughText(), this.texts) : new WalkthroughText();
            this._show();
        };
        /**
         * check if there is a previous step enabled
         */
        /**
         * check if there is a previous step enabled
         * @private
         * @param {?} instance
         * @return {?}
         */
        WalkthroughComponent.prototype._hasPreviousStep = /**
         * check if there is a previous step enabled
         * @private
         * @param {?} instance
         * @return {?}
         */
        function (instance) {
            if (instance.parent) {
                /** @type {?} */
                var current = instance.parent.previousStep;
                while (current) {
                    if (!current.disabled) {
                        return true;
                    }
                    current = current.previousStep;
                }
            }
            return false;
        };
        /**
         * check if there is a next step enabled
         */
        /**
         * check if there is a next step enabled
         * @private
         * @param {?} instance
         * @return {?}
         */
        WalkthroughComponent.prototype._hasNextStep = /**
         * check if there is a next step enabled
         * @private
         * @param {?} instance
         * @return {?}
         */
        function (instance) {
            if (instance.parent) {
                /** @type {?} */
                var current = instance.parent.nextStep;
                while (current) {
                    if (!current.disabled) {
                        return true;
                    }
                    current = current.nextStep;
                }
            }
            return false;
        };
        WalkthroughComponent._walkthroughContainer = null;
        WalkthroughComponent._walkthroughContainerCreating = false;
        WalkthroughComponent.minimalMargin = 30;
        WalkthroughComponent.onOpen = new rxjs.Subject();
        WalkthroughComponent.onRefresh = new rxjs.Subject();
        WalkthroughComponent.onClose = new rxjs.Subject();
        WalkthroughComponent.onNavigate = new rxjs.Subject();
        WalkthroughComponent.onNavigatePrevious = new rxjs.Subject();
        WalkthroughComponent.onNavigateNext = new rxjs.Subject();
        WalkthroughComponent.onFinish = new rxjs.Subject();
        WalkthroughComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ng-walkthrough',
                        template: ''
                    }] }
        ];
        /** @nocollapse */
        WalkthroughComponent.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef },
            { type: core.Injector },
            { type: core.Renderer2 },
            { type: WalkthroughService }
        ]; };
        WalkthroughComponent.propDecorators = {
            closed: [{ type: core.Output }],
            finished: [{ type: core.Output }],
            ready: [{ type: core.Output }],
            focusElementCSSClass: [{ type: core.Input }],
            rootElement: [{ type: core.Input }],
            focusElementSelector: [{ type: core.Input }],
            typeSelector: [{ type: core.Input }],
            focusClick: [{ type: core.Input }],
            radius: [{ type: core.Input }],
            previousStep: [{ type: core.Input }],
            nextStep: [{ type: core.Input }],
            texts: [{ type: core.Input }],
            contentTemplate: [{ type: core.Input }],
            contentText: [{ type: core.Input }],
            contentStyle: [{ type: core.Input }],
            marginZone: [{ type: core.Input }],
            arrowColor: [{ type: core.Input }],
            animation: [{ type: core.Input }],
            animationDelays: [{ type: core.Input }],
            id: [{ type: core.Input }],
            alignContent: [{ type: core.Input }],
            verticalAlignContent: [{ type: core.Input }],
            contentSpacing: [{ type: core.Input }],
            verticalContentSpacing: [{ type: core.Input }],
            closeButton: [{ type: core.Input }],
            closeAnywhere: [{ type: core.Input }],
            showArrow: [{ type: core.Input }],
            finishButton: [{ type: core.Input }],
            focusHighlightAnimation: [{ type: core.Input }],
            focusBackdrop: [{ type: core.Input }],
            focusGlow: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            scrollOnTarget: [{ type: core.Input }],
            visibilityCallback: [{ type: core.Input }],
            resize: [{ type: core.HostListener, args: ['window:resize',] }]
        };
        return WalkthroughComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function throwWalkthroughContentAlreadyAttachedError() {
        throw Error('Attempting to attach walkthrough content after content is already attached');
    }
    /** @type {?} */
    var is_safari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
    var WalkthroughContainerComponent = /** @class */ (function (_super) {
        __extends(WalkthroughContainerComponent, _super);
        function WalkthroughContainerComponent(viewContainerRef, _walkthroughService, _renderer, _el) {
            var _this = _super.call(this) || this;
            _this.viewContainerRef = viewContainerRef;
            _this._walkthroughService = _walkthroughService;
            _this._renderer = _renderer;
            _this._el = _el;
            _this.markerUrl = 'url(#wkt-arrow)';
            /* if a walkthrough is ongoing (paused or not) */
            _this.ongoing = false;
            _this.show = false;
            _this.pause = false;
            // highlight zone
            _this.hasHighlightZone = false;
            _this.hasHighlight = false;
            _this.hasBackdrop = false;
            _this.hasGlow = false;
            // navigate
            _this.hasPrevious = false;
            _this.hasNext = false;
            _this.hasFinish = false;
            _this.hasCloseButton = false;
            _this.hasCloseAnywhere = true;
            // arrow
            _this.hasArrow = false;
            _this.arrowMarkerDist = 7;
            _this.marginZonePx = new WalkthroughMargin();
            // texts change / i18n
            _this.text = new WalkthroughText();
            return _this;
        }
        Object.defineProperty(WalkthroughContainerComponent.prototype, "id", {
            // HostBinding
            get: 
            // HostBinding
            /**
             * @return {?}
             */
            function () {
                return this.parent ? this.parent.id + '-container' : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughContainerComponent.prototype, "hide", {
            get: /**
             * @return {?}
             */
            function () {
                return !this.show;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughContainerComponent.prototype, "cursor", {
            get: /**
             * @return {?}
             */
            function () {
                return this.hasCloseAnywhere;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WalkthroughContainerComponent.prototype, "backdrop", {
            get: /**
             * @return {?}
             */
            function () {
                return !this.hasHighlightZone && this.hasBackdrop;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.click = /**
         * @return {?}
         */
        function () {
            if (this.hasCloseAnywhere && this.show) {
                this.close();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.clickZone = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (this.parent && this.hasClickable) {
                this.parent.focusClick(event, this);
            }
        };
        /**
         * Attach a ComponentPortal as content to this walkthrough container.
         * @param portal Portal to be attached as the walkthrough content.
         */
        /**
         * Attach a ComponentPortal as content to this walkthrough container.
         * @template T
         * @param {?} portal Portal to be attached as the walkthrough content.
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.attachComponentPortal = /**
         * Attach a ComponentPortal as content to this walkthrough container.
         * @template T
         * @param {?} portal Portal to be attached as the walkthrough content.
         * @return {?}
         */
        function (portal) {
            if (this._portalHost.hasAttached()) {
                throwWalkthroughContentAlreadyAttachedError();
            }
            // this._savePreviouslyFocusedElement();
            return this._portalHost.attachComponentPortal(portal);
        };
        /**
         * Attach a TemplatePortal as content to this walkthrough container.
         * @param portal Portal to be attached as the walkthrough content.
         */
        /**
         * Attach a TemplatePortal as content to this walkthrough container.
         * @template C
         * @param {?} portal Portal to be attached as the walkthrough content.
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.attachTemplatePortal = /**
         * Attach a TemplatePortal as content to this walkthrough container.
         * @template C
         * @param {?} portal Portal to be attached as the walkthrough content.
         * @return {?}
         */
        function (portal) {
            if (this._portalHost.hasAttached()) {
                throwWalkthroughContentAlreadyAttachedError();
            }
            // this._savePreviouslyFocusedElement();
            return this._portalHost.attachTemplatePortal(portal);
        };
        /**
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.setHeight = /**
         * @return {?}
         */
        function () {
            this._renderer.setStyle(this._el.nativeElement, 'height', this._walkthroughService.getDocumentHeight() + 'px');
        };
        /**
         * @param {?} coordinate
         * @param {?} scrollDiff
         * @param {?} animation
         * @param {?} animationDelays
         * @param {?} continueFunction
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.hightlightZone = /**
         * @param {?} coordinate
         * @param {?} scrollDiff
         * @param {?} animation
         * @param {?} animationDelays
         * @param {?} continueFunction
         * @return {?}
         */
        function (coordinate, scrollDiff, animation, animationDelays, continueFunction) {
            var _this = this;
            /** @type {?} */
            var element = ((/** @type {?} */ (this.zone.nativeElement)));
            /** @type {?} */
            var zoneStyle = element.style;
            /** @type {?} */
            var style = window.getComputedStyle(element, null);
            if (animation === 'linear' && animationDelays > 0 && style.left !== 'auto') {
                this.hideOther = true;
                /** @type {?} */
                var fragment_1 = 20;
                /** @type {?} */
                var intervale = animationDelays / fragment_1;
                /** @type {?} */
                var left_1 = parseInt(style.left, 10);
                /** @type {?} */
                var top_1 = scrollDiff + parseInt(style.top, 10);
                /** @type {?} */
                var width_1 = parseInt(style.width, 10);
                /** @type {?} */
                var height_1 = parseInt(style.height, 10);
                /** @type {?} */
                var partLeft_1 = (coordinate.left - left_1) / fragment_1;
                /** @type {?} */
                var partTop_1 = (coordinate.top - top_1) / fragment_1;
                /** @type {?} */
                var partWidth_1 = (coordinate.width - width_1) / fragment_1;
                /** @type {?} */
                var partHeight_1 = (coordinate.height - height_1) / fragment_1;
                /** @type {?} */
                var count_1 = 0;
                this.show = true;
                zoneStyle.borderRadius = '50%';
                /** @type {?} */
                var timer_1 = setInterval((/**
                 * @return {?}
                 */
                function () {
                    zoneStyle.left = (left_1 + partLeft_1 * count_1) + 'px';
                    zoneStyle.top = (top_1 + partTop_1 * count_1) + 'px';
                    zoneStyle.width = (width_1 + partWidth_1 * count_1) + 'px';
                    zoneStyle.height = (height_1 + partHeight_1 * count_1) + 'px';
                    if (count_1++ >= fragment_1) {
                        clearInterval(timer_1);
                        _this.hideOther = false;
                        continueFunction();
                    }
                }), intervale);
            }
            else {
                zoneStyle.left = coordinate.left + 'px';
                zoneStyle.top = coordinate.top + 'px';
                zoneStyle.width = coordinate.width + 'px';
                zoneStyle.height = coordinate.height + 'px';
                continueFunction();
            }
        };
        /**
         * @param {?} element
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.hightlightZoneStyling = /**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            if (element) {
                /** @type {?} */
                var zoneStyle = ((/** @type {?} */ (this.zone.nativeElement))).style;
                if (this.radius) {
                    if (Number(this.radius) === parseFloat(this.radius)) {
                        // if is numeric, change in %
                        zoneStyle.borderRadius = this.radius + '%';
                    }
                    else if (this.radius === 'auto') {
                        // if mode auto
                        /** @type {?} */
                        var elementStyle = window.getComputedStyle(element, null);
                        // borderRadius work only on Chrome, use TopLeft, TopRight... for Firefox/Egde/IE
                        zoneStyle.borderTopLeftRadius = elementStyle.borderTopLeftRadius;
                        zoneStyle.borderTopRightRadius = elementStyle.borderTopRightRadius;
                        zoneStyle.borderBottomLeftRadius = elementStyle.borderBottomLeftRadius;
                        zoneStyle.borderBottomRightRadius = elementStyle.borderBottomRightRadius;
                    }
                    else {
                        // if is numeric, change in %
                        zoneStyle.borderRadius = this.radius;
                    }
                }
                else {
                    zoneStyle.borderRadius = '';
                }
            }
        };
        /**
         * @param {?} coordinate
         * @param {?} alignContent
         * @param {?} verticalAlignContent
         * @param {?} contentSpacing
         * @param {?} verticalContentSpacing
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.contentBlockPosition = /**
         * @param {?} coordinate
         * @param {?} alignContent
         * @param {?} verticalAlignContent
         * @param {?} contentSpacing
         * @param {?} verticalContentSpacing
         * @return {?}
         */
        function (coordinate, alignContent, verticalAlignContent, contentSpacing, verticalContentSpacing) {
            /** @type {?} */
            var element = (/** @type {?} */ (this.contentBlock.nativeElement));
            /** @type {?} */
            var elementSize = this._walkthroughService.retrieveCoordinates(element);
            /** @type {?} */
            var width = elementSize.width + elementSize.margin.left + elementSize.margin.right;
            /** @type {?} */
            var height = elementSize.height + elementSize.margin.top + elementSize.margin.bottom;
            // check if we've got the space to respect the alignContent attribute
            /** @type {?} */
            var notEnoughSpace = false;
            if (this.hasHighlightZone) {
                /** @type {?} */
                var spaceLeft = coordinate.left;
                /** @type {?} */
                var spaceRight = window.innerWidth - coordinate.left - coordinate.width;
                if (spaceLeft < width && spaceRight < width) {
                    notEnoughSpace = true;
                }
                // if not enough space to respect the alignContent, content goes above/below
                if ((verticalAlignContent === 'top' ||
                    verticalAlignContent === 'center' ||
                    verticalAlignContent === 'bottom') && !notEnoughSpace) {
                    // change align center to left or right if not enough space to align center
                    if (alignContent === 'center') {
                        /** @type {?} */
                        var maxSpace = Math.max(spaceRight, spaceLeft);
                        if (maxSpace < width + ((window.innerWidth - width) / 2)) {
                            alignContent = spaceRight > spaceLeft ? 'right' : 'left';
                        }
                    }
                    else if (alignContent === 'left' && spaceLeft < width ||
                        alignContent === 'right' && spaceRight < width) {
                        verticalAlignContent = verticalAlignContent === 'bottom' || coordinate.top < height ? 'below' : 'above';
                    }
                }
            }
            // if not enough space on screen width, we center the content
            if (notEnoughSpace) {
                alignContent = 'center';
            }
            // position of content left/center/right
            element.style.right = '';
            element.style.left = '';
            if (alignContent === 'left') {
                element.style.left = '0';
                if (this.hasHighlightZone) {
                    /** @type {?} */
                    var space = coordinate.left - width;
                    // handle contentSpacing
                    if (contentSpacing && space > contentSpacing) {
                        element.style.left = (coordinate.left -
                            width -
                            contentSpacing) + 'px';
                    }
                }
            }
            else if (alignContent === 'center') {
                element.style.left = (window.innerWidth / 2 - width / 2) + 'px';
            }
            else if (alignContent === 'right') {
                element.style.right = '0';
                if (this.hasHighlightZone) {
                    /** @type {?} */
                    var space = window.innerWidth - coordinate.left - coordinate.width - width;
                    // handle contentSpacing
                    if (contentSpacing && space > contentSpacing) {
                        element.style.right = '';
                        element.style.left = (coordinate.left +
                            coordinate.width +
                            contentSpacing) + 'px';
                    }
                }
            }
            if (this.hasHighlightZone) {
                // for arrow position
                /** @type {?} */
                var startLeft = this._walkthroughService.retrieveCoordinates(element).left + width / 2;
                this._arrowPosition = startLeft > (coordinate.left - WalkthroughComponent.minimalMargin)
                    && startLeft < (coordinate.left + coordinate.width + WalkthroughComponent.minimalMargin)
                    ? 'topBottom' : 'leftRight';
                // if there is enough place on the left or on the right, we consider verticalAlignContent, otherwise, we ignore it
                if (verticalAlignContent && !notEnoughSpace) {
                    /** @type {?} */
                    var space = 0;
                    this._contentPosition = verticalAlignContent;
                    switch (verticalAlignContent) {
                        case 'above':
                            space = coordinate.top;
                            if (space > verticalContentSpacing) {
                                element.style.top = (coordinate.top - height - verticalContentSpacing) + 'px';
                            }
                            else {
                                element.style.top = '0';
                            }
                            this._arrowPosition = 'topBottom';
                            break;
                        case 'top':
                            element.style.top = (coordinate.top) + 'px';
                            break;
                        case 'center':
                            element.style.top = (coordinate.top + (coordinate.height / 2) - (height / 2)) + 'px';
                            break;
                        case 'bottom':
                            element.style.top = (coordinate.top + coordinate.height - height) + 'px';
                            break;
                        case 'below':
                            space = this._walkthroughService.getDocumentHeight() - coordinate.top + coordinate.height;
                            if (space > verticalContentSpacing) {
                                element.style.top = (coordinate.top + coordinate.height + verticalContentSpacing) + 'px';
                            }
                            else {
                                element.style.top = (this._walkthroughService.getDocumentHeight() - height) + 'px';
                            }
                            this._arrowPosition = 'topBottom';
                            break;
                    }
                }
                else {
                    // position of content top/bottom
                    if (verticalAlignContent === 'below' || coordinate.top < height) {
                        element.style.top = (coordinate.top + coordinate.height + WalkthroughComponent.minimalMargin) + 'px';
                        this._contentPosition = 'below';
                    }
                    else {
                        element.style.top = (coordinate.top - height - WalkthroughComponent.minimalMargin) + 'px';
                        this._contentPosition = 'above';
                    }
                }
            }
            else {
                element.style.top = (this._walkthroughService.getHeightOfPage() / 2 - height / 2) + 'px';
            }
        };
        /**
         * @param {?} coordinate
         * @param {?} verticalContentSpacing
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.arrowPosition = /**
         * @param {?} coordinate
         * @param {?} verticalContentSpacing
         * @return {?}
         */
        function (coordinate, verticalContentSpacing) {
            /** @type {?} */
            var contentBlockElement = (/** @type {?} */ (this.contentBlock.nativeElement));
            /** @type {?} */
            var contentBlockCoordinates = this._walkthroughService.retrieveCoordinates(contentBlockElement);
            /** @type {?} */
            var startLeft = contentBlockCoordinates.left + contentBlockCoordinates.width / 2;
            /** @type {?} */
            var startTop = contentBlockCoordinates.top + contentBlockCoordinates.height;
            /** @type {?} */
            var centerTop;
            /** @type {?} */
            var centerLeft;
            /** @type {?} */
            var endLeft = coordinate.left;
            /** @type {?} */
            var endTop = coordinate.top + this.marginZonePx.top;
            switch (this._contentPosition) {
                case 'top':
                case 'center':
                case 'bottom':
                    if (contentBlockCoordinates.left > coordinate.left) {
                        startLeft = contentBlockCoordinates.left;
                    }
                    else {
                        startLeft = contentBlockCoordinates.left + contentBlockCoordinates.width;
                    }
                    startTop -= contentBlockCoordinates.height / 2;
                    break;
                case 'below':
                    startTop -= contentBlockCoordinates.height;
                    break;
            }
            if (this._arrowPosition === 'topBottom') {
                endLeft += coordinate.width / 2;
                if (this._contentPosition === 'below') {
                    endTop += coordinate.height + 6;
                }
                else {
                    endTop -= 6;
                }
                centerLeft = (startLeft + endLeft) / 2;
                centerTop = (startTop + endTop) / 2;
                this.arrowPath = "M" + startLeft + "," + startTop + " Q" + startLeft + "," + centerTop + " " + centerLeft + "," + centerTop + " "
                    + ("Q" + endLeft + "," + centerTop + " " + endLeft + "," + endTop);
            }
            else {
                if (startLeft > coordinate.left) {
                    endLeft += coordinate.width + this.arrowMarkerDist;
                }
                else {
                    endLeft -= this.arrowMarkerDist;
                }
                endTop += coordinate.height / 2;
                centerLeft = (startLeft + endLeft) / 2;
                centerTop = (startTop + endTop) / 2;
                /** @type {?} */
                var directStartLeft = startLeft;
                /** @type {?} */
                var directStartTop = startTop;
                if (this._contentPosition === 'top' || this._contentPosition === 'bottom') {
                    directStartLeft = contentBlockCoordinates.left + (contentBlockCoordinates.width / 2);
                    directStartTop = (this._contentPosition === 'top') ?
                        (contentBlockCoordinates.top + contentBlockCoordinates.height) :
                        (contentBlockCoordinates.top);
                    // we use direct curve only if the arrow don't cross the content, otherwise, we use double curved
                    if ((this._contentPosition === 'top' && directStartTop < (endTop - WalkthroughComponent.minimalMargin)) ||
                        (this._contentPosition === 'bottom' && directStartTop > (endTop + WalkthroughComponent.minimalMargin))) {
                        this.arrowPath = "M" + directStartLeft + "," + directStartTop + " Q" + directStartLeft + "," + endTop + " " + endLeft + "," + endTop;
                    }
                    else {
                        this.arrowPath = "M" + startLeft + "," + startTop + " Q" + centerLeft + "," + startTop + " " + centerLeft + "," + centerTop + " "
                            + ("Q" + centerLeft + "," + endTop + " " + endLeft + "," + endTop);
                    }
                }
                else {
                    this.arrowPath = "M" + directStartLeft + "," + directStartTop + " Q" + directStartLeft + "," + endTop + " " + endLeft + "," + endTop;
                }
            }
        };
        /**
         * stop the walkthrough : hide the container and change to pause at true
         */
        /**
         * stop the walkthrough : hide the container and change to pause at true
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.stop = /**
         * stop the walkthrough : hide the container and change to pause at true
         * @return {?}
         */
        function () {
            if (this.parent && !this.pause && this.show) {
                this.show = false;
                this.pause = true;
            }
        };
        /**
         * continue the walkthrough if is stopped : show the container and change to pause at false
         */
        /**
         * continue the walkthrough if is stopped : show the container and change to pause at false
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.continue = /**
         * continue the walkthrough if is stopped : show the container and change to pause at false
         * @return {?}
         */
        function () {
            if (this.parent && this.pause) {
                this.show = true;
                this.pause = false;
                this.parent.refresh();
            }
        };
        /**
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.open = /**
         * @return {?}
         */
        function () {
            // change markerUrl on Safari
            // related to
            // https://gist.github.com/leonderijke/c5cf7c5b2e424c0061d2
            // http://stackoverflow.com/a/18265336/796152
            // http://www.w3.org/TR/SVG/linking.html
            if (is_safari) {
                this.markerUrl = 'url(' + window.location.href + '#wkt-arrow)';
            }
            this.show = true;
        };
        /**
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.previous = /**
         * @return {?}
         */
        function () {
            this.close(false, false);
            // we check if previous walkthrough is not disabled
            /** @type {?} */
            var current = this.parent;
            while (current) {
                if (current.previousStep && !current.previousStep.disabled) {
                    current.loadPrevioustStep();
                    return;
                }
                else {
                    if (!current.previousStep) {
                        break;
                    }
                    current = current.previousStep;
                }
            }
            // no more previous walkthrough enabled, we quit the walkthrough
            this.parent = current;
            this.close(true, true);
        };
        /**
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.next = /**
         * @return {?}
         */
        function () {
            this.close(false, false);
            // we check if next walkthrough is not disabled
            /** @type {?} */
            var current = this.parent;
            while (current) {
                if (current.nextStep && !current.nextStep.disabled) {
                    current.loadNextStep();
                    return;
                }
                else {
                    if (!current.nextStep) {
                        break;
                    }
                    current = current.nextStep;
                }
            }
            // no more next walkthrough enabled, we quit the walkthrough
            this.parent = current;
            this.close(true, true);
        };
        /**
         * @param {?=} finishLink
         * @param {?=} closeWalkthrough
         * @return {?}
         */
        WalkthroughContainerComponent.prototype.close = /**
         * @param {?=} finishLink
         * @param {?=} closeWalkthrough
         * @return {?}
         */
        function (finishLink, closeWalkthrough) {
            if (finishLink === void 0) { finishLink = false; }
            if (closeWalkthrough === void 0) { closeWalkthrough = true; }
            // remove content
            this._portalHost.dispose();
            // hide
            this.show = false;
            if (this.parent) {
                this.parent.hide(finishLink, closeWalkthrough);
            }
        };
        WalkthroughContainerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'walkthrough-container',
                        template: "<div class=\"wkt-container\">\r\n    <div class=\"wkt-zone\"\r\n         #zone\r\n         (click)=\"clickZone($event)\"\r\n         [class.hide]=\"!hasHighlightZone\"\r\n         [class.backdrop]=\"hasBackdrop\"\r\n         [class.glow]=\"hasGlow\"\r\n         [class.clickable]=\"hasClickable\"\r\n         [class.highlight]=\"hasHighlight\"\r\n         [style.padding]=\"marginZone\"></div>\r\n    <div class=\"wkt-content-block\"\r\n         [class.hide]=\"hideOther\"\r\n         [class.darken]=\"contentStyle === 'draken'\"\r\n         #contentBlock>\r\n        <button type=\"button\"\r\n                class=\"wkt-close\"\r\n                *ngIf=\"hasCloseButton\"\r\n                (click)=\"close()\">\u2716</button>\r\n        <div class=\"wkt-content\">\r\n            <p *ngIf=\"contentText\">{{contentText}}</p>\r\n            <ng-template cdkPortalHost></ng-template>\r\n        </div>\r\n        <div class=\"wkt-navigate\"\r\n             *ngIf=\"hasPrevious||hasNext||hasFinish\">\r\n            <button type=\"button\"\r\n                    class=\"wkt-previous-link\"\r\n                    *ngIf=\"hasPrevious\"\r\n                    (click)=\"previous()\">{{text.previous}}</button>\r\n            <button type=\"button\"\r\n                    class=\"wkt-next-link\"\r\n                    *ngIf=\"hasNext\"\r\n                    (click)=\"next()\">{{text.next}}</button>\r\n            <button type=\"button\"\r\n                    class=\"wkt-finish-link\"\r\n                    *ngIf=\"hasFinish\"\r\n                    (click)=\"close(true)\">{{text.close}}</button>\r\n        </div>\r\n    </div>\r\n    <div *ngIf=\"hasArrow\"\r\n         [class.hide]=\"hideOther\">\r\n        <svg version=\"1.1\"\r\n             xmlns=\"http://www.w3.org/2000/svg\"\r\n             width=\"100%\"\r\n             height=\"100%\">\r\n            <defs>\r\n                <marker id=\"wkt-arrow\"\r\n                        viewBox=\"0 0 10 10\"\r\n                        refX=\"8\"\r\n                        refY=\"5\"\r\n                        markerUnits=\"strokeWidth\"\r\n                        orient=\"auto\"\r\n                        markerWidth=\"10\"\r\n                        markerHeight=\"10\">\r\n                    <polyline points=\"0,0 10,5 0,10 5,5\"\r\n                              stroke-width=\"0\"\r\n                              [attr.fill]=\"arrowColor || '#FFF'\" />\r\n                </marker>\r\n            </defs>\r\n            <path class=\"wkt-arrow-path\"\r\n                  [attr.d]=\"arrowPath\"\r\n                  [attr.stroke]=\"arrowColor || '#FFF'\"\r\n                  [attr.marker-end]=\"markerUrl\" />\r\n        </svg>\r\n    </div>\r\n</div>",
                        styles: [":host{display:block;position:absolute;z-index:1;top:0;left:0;width:99.9%;min-height:100%}:host.hide{display:none}:host.cursor{cursor:pointer}:host.backdrop{background-color:rgba(0,0,0,.6)}button{background:0 0;border:0;color:#fff}.wkt-zone{position:absolute}.wkt-zone.hide{display:none}.wkt-zone.backdrop{box-shadow:0 0 0 2200px rgba(0,0,0,.6)}.wkt-zone.glow{box-shadow:0 0 4px 2px #ff6,0 0 9px 0 #ff6,0 0 36px #ff6}.wkt-zone.clickable{cursor:pointer}.wkt-zone.highlight{-webkit-animation:.45s 4 highlight;animation:.45s 4 highlight}.wkt-container{position:relative}.wkt-content-block{position:absolute;margin:1em;padding:6px;z-index:1;color:#fff;min-width:calc(320px - 2em)}.wkt-content-block.hide{display:none}.wkt-content-block.darken{background-color:rgba(0,0,0,.6)}.wkt-close+.wkt-content{margin-top:1.3em}.wkt-close{position:absolute;right:1em;cursor:pointer}.wkt-navigate{display:flex;flex-wrap:wrap;justify-content:center}.wkt-navigate>button{padding:6px;font-size:120%}.wkt-navigate>button:hover{cursor:pointer;text-decoration:underline}.wkt-previous-link::before{content:\"<< \"}.wkt-next-link::after{content:\" >>\"}div.hide{display:none}svg{overflow:visible;position:absolute;top:-1px;left:-1px;border:1px solid transparent}#wkt-arrow>path{stroke-width:0}.wkt-arrow-path{stroke-width:2px;fill:none}@-webkit-keyframes highlight{0%,100%{background-color:none}50%{background-color:rgba(255,255,255,.8)}}@keyframes highlight{0%,100%{background-color:none}50%{background-color:rgba(255,255,255,.8)}}@media screen and (min-width:1920px),screen and (min-height:1920px){.wkt-zone.backdrop{box-shadow:0 0 0 4400px rgba(0,0,0,.6)}}@media screen and (min-width:3840px),screen and (min-height:3840px){.wkt-zone.backdrop{box-shadow:0 0 0 8800px rgba(0,0,0,.6)}}_:default:not(:root:root),.wkt-zone.backdrop{box-shadow:0 0 0 2000px rgba(0,0,0,.6)!important}"]
                    }] }
        ];
        /** @nocollapse */
        WalkthroughContainerComponent.ctorParameters = function () { return [
            { type: core.ViewContainerRef },
            { type: WalkthroughService },
            { type: core.Renderer2 },
            { type: core.ElementRef }
        ]; };
        WalkthroughContainerComponent.propDecorators = {
            _portalHost: [{ type: core.ViewChild, args: [portal.PortalHostDirective,] }],
            content: [{ type: core.ViewChild, args: ['content',] }],
            contentBlock: [{ type: core.ViewChild, args: ['contentBlock',] }],
            zone: [{ type: core.ViewChild, args: ['zone',] }],
            id: [{ type: core.HostBinding, args: ['attr.id',] }],
            hide: [{ type: core.HostBinding, args: ['class.hide',] }],
            cursor: [{ type: core.HostBinding, args: ['class.cursor',] }],
            backdrop: [{ type: core.HostBinding, args: ['class.backdrop',] }],
            click: [{ type: core.HostListener, args: ['click',] }]
        };
        return WalkthroughContainerComponent;
    }(portal.BasePortalHost));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nextUniqueId$1 = 0;
    var WalkthroughFlowComponent = /** @class */ (function () {
        function WalkthroughFlowComponent() {
            this.closed = new core.EventEmitter();
            this.finished = new core.EventEmitter();
            this.contentStyle = 'draken';
            this.marginZone = null;
            this._uid = "walkthrough-flow-" + nextUniqueId$1++;
        }
        Object.defineProperty(WalkthroughFlowComponent.prototype, "id", {
            get: /**
             * @return {?}
             */
            function () { return this._id; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._id = value || this._uid; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        WalkthroughFlowComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.init();
            }), 0);
        };
        /**
         * @return {?}
         */
        WalkthroughFlowComponent.prototype.init = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var prevComp = null;
            this.walkthroughComponents.forEach((/**
             * @param {?} walkthrough
             * @return {?}
             */
            function (walkthrough) {
                // navigation auto (ignore previousStep/nextStep on the WalkthroughComponent)
                if (prevComp) {
                    walkthrough.previousStep = prevComp;
                    prevComp.nextStep = walkthrough;
                }
                prevComp = walkthrough;
                // transmition (only if different from default)
                if (_this.closed) {
                    walkthrough.closed = _this.closed;
                }
                if (_this.finished) {
                    walkthrough.finished = _this.finished;
                }
                if (!walkthrough.contentStyle && _this.contentStyle) {
                    walkthrough.contentStyle = _this.contentStyle;
                }
                if (!walkthrough.arrowColor && _this.arrowColor) {
                    walkthrough.arrowColor = _this.arrowColor;
                }
                if (!walkthrough.marginZone && _this.marginZone) {
                    walkthrough.marginZone = _this.marginZone;
                }
                if (!walkthrough.showArrow && booleanValue(_this.showArrow)) {
                    walkthrough.showArrow = _this.showArrow;
                }
                if (!walkthrough.rootElement && _this.rootElement) {
                    walkthrough.rootElement = _this.rootElement;
                }
                if (!walkthrough.closeButton && booleanValue(_this.closeButton)) {
                    walkthrough.closeButton = _this.closeButton;
                }
                if (walkthrough.closeAnywhere && !booleanValue(_this.closeAnywhere)) {
                    walkthrough.closeAnywhere = _this.closeAnywhere;
                }
                if (!walkthrough.finishButton && booleanValue(_this.finishButton)) {
                    walkthrough.finishButton = _this.finishButton;
                }
                if (!walkthrough.focusBackdrop && booleanValue(_this.focusBackdrop)) {
                    walkthrough.focusBackdrop = _this.focusBackdrop;
                }
                if (!walkthrough.focusGlow && booleanValue(_this.focusGlow)) {
                    walkthrough.focusGlow = _this.focusGlow;
                }
                if (!walkthrough.radius && _this.radius) {
                    walkthrough.radius = _this.radius;
                }
                if (!walkthrough.texts && _this.texts) {
                    walkthrough.texts = _this.texts;
                }
            }));
            // navigation auto (close on last step)
            prevComp.finishButton = true;
        };
        /**
         * @return {?}
         */
        WalkthroughFlowComponent.prototype.start = /**
         * @return {?}
         */
        function () {
            this.walkthroughComponents.first.open();
        };
        WalkthroughFlowComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ng-walkthrough-flow',
                        template: ''
                    }] }
        ];
        /** @nocollapse */
        WalkthroughFlowComponent.ctorParameters = function () { return []; };
        WalkthroughFlowComponent.propDecorators = {
            walkthroughComponents: [{ type: core.ContentChildren, args: [WalkthroughComponent,] }],
            id: [{ type: core.Input }],
            closed: [{ type: core.Output }],
            finished: [{ type: core.Output }],
            contentStyle: [{ type: core.Input }],
            arrowColor: [{ type: core.Input }],
            marginZone: [{ type: core.Input }],
            showArrow: [{ type: core.Input }],
            rootElement: [{ type: core.Input }],
            closeButton: [{ type: core.Input }],
            closeAnywhere: [{ type: core.Input }],
            finishButton: [{ type: core.Input }],
            focusBackdrop: [{ type: core.Input }],
            focusGlow: [{ type: core.Input }],
            radius: [{ type: core.Input }],
            texts: [{ type: core.Input }]
        };
        return WalkthroughFlowComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WalkthroughModule = /** @class */ (function () {
        function WalkthroughModule() {
        }
        WalkthroughModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            portal.PortalModule
                        ],
                        declarations: [
                            WalkthroughFlowComponent,
                            WalkthroughComponent,
                            WalkthroughContainerComponent
                        ],
                        exports: [
                            WalkthroughFlowComponent,
                            WalkthroughComponent,
                            WalkthroughContainerComponent
                        ],
                        entryComponents: [
                            WalkthroughContainerComponent
                        ],
                        providers: [
                            WalkthroughService
                        ]
                    },] }
        ];
        return WalkthroughModule;
    }());

    exports.WalkthroughComponent = WalkthroughComponent;
    exports.WalkthroughContainerComponent = WalkthroughContainerComponent;
    exports.WalkthroughEvent = WalkthroughEvent;
    exports.WalkthroughFlowComponent = WalkthroughFlowComponent;
    exports.WalkthroughMargin = WalkthroughMargin;
    exports.WalkthroughModule = WalkthroughModule;
    exports.WalkthroughService = WalkthroughService;
    exports.WalkthroughText = WalkthroughText;
    exports.booleanValue = booleanValue;
    exports.throwWalkthroughContentAlreadyAttachedError = throwWalkthroughContentAlreadyAttachedError;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular-walkthrough.umd.js.map
